## libjson-rpc-cpp 0.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(libjson-rpc-cpp)

# list command no longer ignores empty elements 
cmake_policy(SET CMP0007 NEW)
cmake_policy(SET CMP0012 NEW)

if (${CMAKE_MAJOR_VERSION} GREATER 2)
	# old policy do not use MACOSX_RPATH
	cmake_policy(SET CMP0042 OLD)
endif()

set(MAJOR_VERSION 0)
set(MINOR_VERSION 7)
set(PATCH_VERSION 0)
set(SO_VERSION    0)

set(BUILD_SHARED_LIBS YES CACHE BOOL "Build shared libraries")
set(BUILD_STATIC_LIBS NO CACHE BOOL "Build static libraries")
set(LIB_SUFFIX "" CACHE STRING "Suffix for library directory (32/64)")

if (NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
	message(FATAL_ERROR "Both BUILD_SHARED_LIBS and BUILD_STATIC_LIBS are disabled")
endif()

# defaults for modules that can be enabled/disabled
if(UNIX)
	set(UNIX_DOMAIN_SOCKET_SERVER YES CACHE BOOL "Include Unix Domain Socket server")
	set(UNIX_DOMAIN_SOCKET_CLIENT YES CACHE BOOL "Include Unix Domain Socket client")
endif(UNIX)
set(TCP_SOCKET_SERVER NO CACHE BOOL "Include Tcp Socket server")
set(TCP_SOCKET_CLIENT NO CACHE BOOL "Include Tcp Socket client")
set(HTTP_SERVER YES CACHE BOOL "Include HTTP server using libmicrohttpd")
set(HTTP_CLIENT YES CACHE BOOL "Include HTTP client support using curl")
set(COMPILE_TESTS YES CACHE BOOL "Compile test framework")
set(COMPILE_STUBGEN YES CACHE BOOL "Compile the stubgenerator")
set(COMPILE_EXAMPLES YES CACHE BOOL "Compile example programs")

# print actual settings
if(UNIX)
	message(STATUS "UNIX_DOMAIN_SOCKET_SERVER: ${UNIX_DOMAIN_SOCKET_SERVER}")
	message(STATUS "UNIX_DOMAIN_SOCKET_CLIENT: ${UNIX_DOMAIN_SOCKET_CLIENT}")
endif(UNIX)
message(STATUS "TCP_SOCKET_SERVER: ${TCP_SOCKET_SERVER}")
message(STATUS "TCP_SOCKET_CLIENT: ${TCP_SOCKET_CLIENT}")
message(STATUS "HTTP_SERVER: ${HTTP_SERVER}")
message(STATUS "HTTP_CLIENT: ${HTTP_CLIENT}")
if(UNIX)
    message(STATUS "UNIXDOMAINSOCKET_SERVER: ${UNIX_DOMAIN_SOCKET_SERVER}")
    message(STATUS "UNIXDOMAINSOCKET_CLIENT: ${UNIX_DOMAIN_SOCKET_CLIENT}")
endif(UNIX)
message(STATUS "COMPILE_TESTS: ${COMPILE_TESTS}")
message(STATUS "COMPILE_STUBGEN: ${COMPILE_STUBGEN}")
message(STATUS "COMPILE_EXAMPLES: ${COMPILE_EXAMPLES}")

# setup directory where we should look for cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

# setup compiler settings && dependencies
include(CMakeCompilerSettings)
include(CMakeDependencies)

# setup output directories
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")

if (WIN32)
	set(CMAKE_INSTALL_PREFIX ${PROJECT_BINARY_DIR}/dist)
endif()

# setup global include_directories (for backwards compatibility)
include_directories("${CMAKE_BINARY_DIR}/gen/")
include_directories("${CMAKE_BINARY_DIR}/gen/jsonrpccpp/common")

# the core framework
add_subdirectory(src/jsonrpccpp)

#the stubgenerator
if (COMPILE_STUBGEN)
	add_subdirectory(src/stubgenerator)
endif ()

# setup examples
if (COMPILE_EXAMPLES)
	add_subdirectory(src/examples)
endif()

# setup test suite
if (COMPILE_TESTS)
        enable_testing(true)
	add_subdirectory(src/test)
endif()

# create documentation
if (DOXYGEN_FOUND)
	file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doc)
	message(STATUS "Found doxygen: ${DOXYGEN_EXECUTABLE}")
	configure_file("${PROJECT_SOURCE_DIR}/doc/doxyfile.in" "${CMAKE_BINARY_DIR}/Doxyfile" @ONLY)
	add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/doc COMMENT "Generating API documentation")
endif(DOXYGEN_FOUND)

# setup uninstall target
configure_file(
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY
)

add_custom_target(
	uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

# packaging stuff
include(CMakePackaging)

=== src/catch/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(catch_builder CXX)
include(ExternalProject)
find_package(Git REQUIRED)

ExternalProject_Add(
    catch
    PREFIX ${CMAKE_BINARY_DIR}/catch
    GIT_REPOSITORY https://github.com/philsquared/Catch.git
    TIMEOUT 10
    UPDATE_COMMAND ${GIT_EXECUTABLE} pull
    CONFIGURE_COMMAND ""
    BUILD_COMMAND ""
    INSTALL_COMMAND ""
    LOG_DOWNLOAD ON
   )

# Expose required variable (CATCH_INCLUDE_DIR) to parent scope
ExternalProject_Get_Property(catch source_dir)
set(CATCH_INCLUDE_DIR ${source_dir}/include CACHE INTERNAL "Path to include folder for Catch")

=== src/examples/CMakeLists.txt ===
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/gen)

add_custom_command(
	OUTPUT ${CMAKE_BINARY_DIR}/gen/abstractstubserver.h
	COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/spec.json --cpp-server=AbstractStubServer --cpp-server-file=${CMAKE_BINARY_DIR}/gen/abstractstubserver.h
	MAIN_DEPENDENCY spec.json
	DEPENDS jsonrpcstub
	COMMENT "Generating Server Stubfiles"
	VERBATIM
)

add_custom_command(
	OUTPUT ${CMAKE_BINARY_DIR}/gen/stubclient.h
	COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/spec.json --cpp-client=StubClient --cpp-client-file=${CMAKE_BINARY_DIR}/gen/stubclient.h
	MAIN_DEPENDENCY spec.json
	DEPENDS jsonrpcstub
	COMMENT "Generating Client Stubfile"
	VERBATIM
)

add_custom_target(common_stubs
	DEPENDS ${CMAKE_BINARY_DIR}/gen/abstractstubserver.h ${CMAKE_BINARY_DIR}/gen/stubclient.h
)

add_custom_command(
	OUTPUT ${CMAKE_BINARY_DIR}/gen/xbmcremote.h
	COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/xbmc_remote.json --cpp-client=XbmcRemoteClient --cpp-client-file=${CMAKE_BINARY_DIR}/gen/xbmcremote.h
	MAIN_DEPENDENCY xbmc_remote.json
	DEPENDS jsonrpcstub
	COMMENT "Generating Client XBMC Stubfile"
	VERBATIM
)

include_directories(..)
include_directories(${CMAKE_BINARY_DIR})
include_directories(${JSONCPP_INCLUDE_DIRS})
include_directories(${MHD_INCLUDE_DIRS})

if(UNIX)
	if (UNIX_DOMAIN_SOCKET_SERVER AND UNIX_DOMAIN_SOCKET_CLIENT)
		add_executable(unixdomainsocketserversample unixdomainsocketserver.cpp)
		target_link_libraries(unixdomainsocketserversample jsonrpcserver)
	
		add_executable(unixdomainsocketclientsample unixdomainsocketclient.cpp)
		target_link_libraries(unixdomainsocketclientsample jsonrpcclient)
	endif (UNIX_DOMAIN_SOCKET_SERVER AND UNIX_DOMAIN_SOCKET_CLIENT)
endif(UNIX)

if (TCP_SOCKET_SERVER AND TCP_SOCKET_CLIENT)
	add_executable(tcpsocketclient tcpsocketclient.cpp)
	target_link_libraries(tcpsocketclient jsonrpcclient)
	
	add_executable(tcpsocketserver tcpsocketserver.cpp)
	target_link_libraries(tcpsocketserver jsonrpcserver)
endif (TCP_SOCKET_SERVER AND TCP_SOCKET_CLIENT)

if(HTTP_SERVER)
    add_executable(simpleserversample simpleserver.cpp)
    target_link_libraries(simpleserversample jsonrpcserver)
endif()

if(HTTP_CLIENT)
    add_executable(simpleclientsample simpleclient.cpp)
    target_link_libraries(simpleclientsample jsonrpcclient)
endif()

if (COMPILE_STUBGEN)
    if(HTTP_CLIENT)
            add_executable(stubclientsample stubclient.cpp ${CMAKE_BINARY_DIR}/gen/stubclient.h)
            target_link_libraries(stubclientsample jsonrpcclient)
        add_executable(xbmcremote xbmcremote.cpp ${CMAKE_BINARY_DIR}/gen/xbmcremote.h)
        target_link_libraries(xbmcremote jsonrpcclient)
    endif()

    if(HTTP_SERVER)
        add_executable(stubserversample stubserver.cpp ${CMAKE_BINARY_DIR}/gen/abstractstubserver.h)
        target_link_libraries(stubserversample jsonrpcserver)
    endif()
endif()

=== src/jsonrpccpp/CMakeLists.txt ===
# setup common headers and sources
file(GLOB jsonrpc_header *.h)
file(GLOB jsonrpc_header_common common/*.h)
file(GLOB jsonrpc_source_common common/*.c*)

# setup server headers and sources
file(GLOB jsonrpc_install_header_server 
	server/requesthandlerfactory.h
	server/abstractserver.h
	server/abstractserverconnector.h
	server/iprocedureinvokationhandler.h
	server/iclientconnectionhandler.h
)
file(GLOB jsonrpc_header_server server/*.h)
file(GLOB jsonrpc_source_server server/*.c*)

# setup client headers and sources
file(GLOB jsonrpc_install_header_client
	client/batchcall.h
	client/batchresponse.h
	client/client.h
	client/iclientconnector.h
)
file(GLOB jsonrpc_header_client client/*.h)
file(GLOB jsonrpc_source_client client/*.c*)

# setup connector variables defaults
set(client_connector_source "")
set(client_connector_header "")
set(client_connector_libs   "")
set(server_connector_source "")
set(server_connector_header "")
set(server_connector_libs   "")

# setup sources for http connectors
if (HTTP_CLIENT)
	list(APPEND client_connector_header "client/connectors/httpclient.h")
	list(APPEND client_connector_source "client/connectors/httpclient.cpp")
	list(APPEND client_connector_libs ${CURL_LIBRARIES})
    include_directories(${CURL_INCLUDE_DIRS})
endif()

if (HTTP_SERVER)
	list(APPEND server_connector_header "server/connectors/httpserver.h")
	list(APPEND server_connector_source "server/connectors/httpserver.cpp")
	list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT} ${MHD_LIBRARIES})  
endif()

# setup sources for unix domain socket connectors
if (UNIX_DOMAIN_SOCKET_SERVER)
	list(APPEND server_connector_header "server/connectors/unixdomainsocketserver.h")
	list(APPEND server_connector_source "server/connectors/unixdomainsocketserver.cpp")
	list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif()

if (UNIX_DOMAIN_SOCKET_CLIENT)
	list(APPEND client_connector_header "client/connectors/unixdomainsocketclient.h")
	list(APPEND client_connector_source "client/connectors/unixdomainsocketclient.cpp")
endif()

# setup sources for tcp socket connectors
if (TCP_SOCKET_SERVER)
	list(APPEND server_connector_header "server/connectors/tcpsocketserver.h")
	list(APPEND server_connector_source "server/connectors/tcpsocketserver.cpp")
	if (WIN32)
		list(APPEND server_connector_header "server/connectors/windowstcpsocketserver.h")
		list(APPEND server_connector_source "server/connectors/windowstcpsocketserver.cpp")
		list(APPEND server_connector_libs ws2_32)
	endif()
	if(UNIX)
		list(APPEND server_connector_header "server/connectors/linuxtcpsocketserver.h")
		list(APPEND server_connector_source "server/connectors/linuxtcpsocketserver.cpp")
	endif()
	list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif()

if (TCP_SOCKET_CLIENT)
	list(APPEND client_connector_header "client/connectors/tcpsocketclient.h")
	list(APPEND client_connector_source "client/connectors/tcpsocketclient.cpp")
	if (WIN32)
		list(APPEND client_connector_header "client/connectors/windowstcpsocketclient.h")
		list(APPEND client_connector_source "client/connectors/windowstcpsocketclient.cpp")
		list(APPEND client_connector_libs ws2_32)
	endif()
	if(UNIX)
		list(APPEND client_connector_header "client/connectors/linuxtcpsocketclient.h")
		list(APPEND client_connector_source "client/connectors/linuxtcpsocketclient.cpp")
	endif()
	list(APPEND client_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif()

# configure a header file to pass some of the CMake settings to the source code
# TODO: move it to custom build step?
file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/gen/jsonrpccpp/common")
configure_file("${PROJECT_SOURCE_DIR}/src/jsonrpccpp/version.h.in" "${CMAKE_BINARY_DIR}/gen/jsonrpccpp/version.h")
configure_file("${PROJECT_SOURCE_DIR}/src/jsonrpccpp/common/jsonparser.h.in" "${CMAKE_BINARY_DIR}/gen/jsonrpccpp/common/jsonparser.h")

install(FILES "${CMAKE_BINARY_DIR}/gen/jsonrpccpp/version.h" DESTINATION include/jsonrpccpp)
install(FILES "${PROJECT_BINARY_DIR}/gen/jsonrpccpp/common/jsonparser.h" DESTINATION include/jsonrpccpp/common)

# include required directories
include_directories(..)
include_directories(${JSONCPP_INCLUDE_DIRS})
include_directories(${MHD_INCLUDE_DIRS})

# setup shared common library
if (BUILD_SHARED_LIBS)
	add_library(jsonrpccommon SHARED ${jsonrpc_source_common} ${jsonrpc_header} ${jsonrpc_helper_source_common})
	target_link_libraries(jsonrpccommon ${JSONCPP_LIBRARIES})
	set_target_properties(jsonrpccommon PROPERTIES OUTPUT_NAME jsonrpccpp-common)
endif()

# setup static common library
if (BUILD_STATIC_LIBS OR MSVC)
	add_library(jsonrpccommonStatic STATIC ${jsonrpc_source_common} ${jsonrpc_header} ${jsonrpc_helper_source_common})
	target_link_libraries(jsonrpccommonStatic ${JSONCPP_LIBRARIES})
	set_target_properties(jsonrpccommonStatic PROPERTIES OUTPUT_NAME jsonrpccpp-common)

	if (NOT BUILD_SHARED_LIBS)
		add_library(jsonrpccommon ALIAS jsonrpccommonStatic)
	endif()
endif()

# setup shared client library
if (BUILD_SHARED_LIBS)
	add_library(jsonrpcclient SHARED ${jsonrpc_source_client} ${jsonrpc_header} ${jsonrpc_header_client} ${client_connector_source})
	add_dependencies(jsonrpcclient jsonrpccommon)
	target_link_libraries(jsonrpcclient jsonrpccommon ${client_connector_libs})
	set_target_properties(jsonrpcclient PROPERTIES OUTPUT_NAME jsonrpccpp-client)
endif()

# setup static client library
if (BUILD_STATIC_LIBS OR MSVC)
	add_library(jsonrpcclientStatic STATIC ${jsonrpc_source_client} ${jsonrpc_header} ${jsonrpc_header_client} ${client_connector_source})
	target_link_libraries(jsonrpcclientStatic jsonrpccommonStatic ${client_connector_libs})
	set_target_properties(jsonrpcclientStatic PROPERTIES OUTPUT_NAME jsonrpccpp-client)

	if (NOT BUILD_SHARED_LIBS)
		add_library(jsonrpcclient ALIAS jsonrpcclientStatic)
	endif()
endif()

# setup shared server library
if (BUILD_SHARED_LIBS)
	add_library(jsonrpcserver SHARED ${jsonrpc_source_server} ${jsonrpc_header} ${jsonrpc_header_server} ${server_connector_source})
	add_dependencies(jsonrpcserver jsonrpccommon)
	target_link_libraries(jsonrpcserver jsonrpccommon ${server_connector_libs})
	set_target_properties(jsonrpcserver PROPERTIES OUTPUT_NAME jsonrpccpp-server)
endif()

# setup static server library
if (BUILD_STATIC_LIBS OR MSVC)
	add_library(jsonrpcserverStatic STATIC ${jsonrpc_source_server} ${jsonrpc_header} ${jsonrpc_header_server} ${server_connector_source})
	target_link_libraries(jsonrpcserverStatic jsonrpccommonStatic ${server_connector_libs})
	set_target_properties(jsonrpcserverStatic PROPERTIES OUTPUT_NAME jsonrpccpp-server)

	if (NOT BUILD_SHARED_LIBS)
		add_library(jsonrpcserver ALIAS jsonrpcserverStatic)
	endif()
endif()

set(ALL_LIBS)

if (BUILD_SHARED_LIBS OR NOT BUILD_STATIC_LIBS)
	list(APPEND ALL_LIBS jsonrpccommon jsonrpcclient jsonrpcserver)
endif()

if (BUILD_STATIC_LIBS OR MSVC)
	list(APPEND ALL_LIBS jsonrpccommonStatic jsonrpcclientStatic jsonrpcserverStatic)
endif()

# setup version
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})
set_target_properties(
	${ALL_LIBS}
	PROPERTIES VERSION "${VERSION_STRING}" SOVERSION "${SO_VERSION}"
)

# install libraries
install(FILES ${jsonrpc_header}                 DESTINATION include/jsonrpccpp)
install(FILES ${jsonrpc_header_common}          DESTINATION include/jsonrpccpp/common)
install(FILES ${jsonrpc_helper_header_common}   DESTINATION include/jsonrpccpp/common/helper)
install(FILES ${jsonrpc_install_header_client}  DESTINATION include/jsonrpccpp/client)
install(FILES ${jsonrpc_install_header_server}  DESTINATION include/jsonrpccpp/server)
install(FILES ${client_connector_header}        DESTINATION include/jsonrpccpp/client/connectors)
install(FILES ${server_connector_header}        DESTINATION include/jsonrpccpp/server/connectors)

if (WIN32)
	file(GLOB win32_libs ${CMAKE_SOURCE_DIR}/win32-deps/lib/*.dll)
	file(COPY ${win32_libs} DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
	install(FILES ${win32_libs} DESTINATION bin)
	install(DIRECTORY ${CMAKE_SOURCE_DIR}/win32-deps/include DESTINATION .)
endif()

install(TARGETS ${ALL_LIBS}
	LIBRARY DESTINATION lib${LIB_SUFFIX}/${CMAKE_LIBRARY_PATH}
	ARCHIVE DESTINATION lib${LIB_SUFFIX}/${CMAKE_LIBRARY_PATH}
	RUNTIME DESTINATION bin
)

#set pkg-config
get_filename_component(FULL_PATH_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} ABSOLUTE)
set(FULL_PATH_INCLUDEDIR "${FULL_PATH_INSTALL_PREFIX}/include")
set(FULL_PATH_LIBDIR "${FULL_PATH_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_PATH}")

CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/cmake/libjsonrpccpp-client.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-client.pc)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/cmake/libjsonrpccpp-server.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-server.pc)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/cmake/libjsonrpccpp-common.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-common.pc)

INSTALL(FILES 
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-server.pc"
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-client.pc"
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-common.pc"
    DESTINATION "lib${LIB_SUFFIX}/${CMAKE_LIBRARY_PATH}/pkgconfig")

=== src/stubgenerator/CMakeLists.txt ===
file(GLOB_RECURSE jsonrpcstub_source *.cpp)
file(GLOB_RECURSE jsonrpcstub_header *.h)
list(REMOVE_ITEM jsonrpcstub_source "${CMAKE_CURRENT_SOURCE_DIR}/main.cpp")

include_directories(..)
include_directories(${JSONCPP_INCLUDE_DIRS})
include_directories(${ARGTABLE_INCLUDE_DIRS})

set(ALL_LIBS)


if (BUILD_SHARED_LIBS)
        add_library(libjsonrpcstub SHARED ${jsonrpcstub_source} ${jsonrpcstub_header} ${jsonrpc_helper_source_common})
        target_link_libraries(libjsonrpcstub jsonrpccommon ${JSONCPP_LIBRARIES} ${ARGTABLE_LIBRARIES})
        set_target_properties(libjsonrpcstub PROPERTIES OUTPUT_NAME jsonrpccpp-stub)
        list(APPEND ALL_LIBS libjsonrpcstub)
endif()

# setup static common library
if (BUILD_STATIC_LIBS)
        add_library(libjsonrpcstubStatic STATIC ${jsonrpcstub_source} ${jsonrpcstub_header} ${jsonrpc_helper_source_common})
        target_link_libraries(libjsonrpcstubStatic jsonrpccommonStatic ${JSONCPP_LIBRARIES} ${ARGTABLE_LIBRARIES})
        set_target_properties(libjsonrpcstubStatic PROPERTIES OUTPUT_NAME jsonrpccpp-stub)

        if (NOT BUILD_SHARED_LIBS)
                add_library(libjsonrpcstub ALIAS libjsonrpcstubStatic)
        endif()

        list(APPEND ALL_LIBS libjsonrpcstubStatic)
endif()

set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION})
set_target_properties(
        ${ALL_LIBS}
        PROPERTIES VERSION "${VERSION_STRING}" SOVERSION "${SO_VERSION}"
)


add_executable(jsonrpcstub main.cpp)
target_link_libraries(jsonrpcstub jsonrpccommon libjsonrpcstub )

#Generate manpage
if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
	configure_file("${CMAKE_SOURCE_DIR}/doc/manpage.in" "${CMAKE_BINARY_DIR}/manpage" @ONLY)
	add_custom_command(OUTPUT jsonrpcstub.1.gz
		COMMAND gzip -c "${CMAKE_BINARY_DIR}/manpage" > ${CMAKE_BINARY_DIR}/jsonrpcstub.1.gz
		COMMENT "Generating man pages"
		VERBATIM
	)

	add_custom_target(manpage ALL DEPENDS jsonrpcstub.1.gz)
	install(FILES ${CMAKE_BINARY_DIR}/jsonrpcstub.1.gz DESTINATION share/man/man1/)
	add_dependencies(jsonrpcstub manpage)

endif()

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/cmake/libjsonrpccpp-stub.pc.cmake ${CMAKE_BINARY_DIR}/libjsonrpccpp-stub.pc)

INSTALL(FILES
    "${CMAKE_BINARY_DIR}/libjsonrpccpp-stub.pc"
    DESTINATION "lib/${CMAKE_LIBRARY_PATH}/pkgconfig")

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/stubgenerator/
        DESTINATION include/jsonrpccpp/stubgen
        FILES_MATCHING PATTERN "*.h")

install(TARGETS ${ALL_LIBS} jsonrpcstub
        LIBRARY DESTINATION lib${LIB_SUFFIX}/${CMAKE_LIBRARY_PATH}
        ARCHIVE DESTINATION lib${LIB_SUFFIX}/${CMAKE_LIBRARY_PATH}
        RUNTIME DESTINATION bin
)

=== src/test/CMakeLists.txt ===

set(CTEST_OUTPUT_ON_FAILURE TRUE)
file(GLOB_RECURSE test_source *.cpp)

include_directories(..)
include_directories(${CMAKE_BINARY_DIR})
include_directories(${JSONCPP_INCLUDE_DIRS})

add_custom_command(
        OUTPUT ${CMAKE_BINARY_DIR}/gen/abstractstubserver.h
        COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/spec.json --cpp-server=AbstractStubServer --cpp-server-file=${CMAKE_BINARY_DIR}/gen/abstractstubserver.h
        MAIN_DEPENDENCY spec.json
        DEPENDS jsonrpcstub
        COMMENT "Generating Server Stubfiles"
        VERBATIM
)

add_custom_command(
        OUTPUT ${CMAKE_BINARY_DIR}/gen/stubclient.h
        COMMAND jsonrpcstub ARGS ${CMAKE_CURRENT_SOURCE_DIR}/spec.json --cpp-client=StubClient --cpp-client-file=${CMAKE_BINARY_DIR}/gen/stubclient.h
        MAIN_DEPENDENCY spec.json
        DEPENDS jsonrpcstub
        COMMENT "Generating Client Stubfile"
        VERBATIM
)


if(HTTP_CLIENT AND HTTP_SERVER)
        add_definitions(-DHTTP_TESTING)
        file(COPY ${CMAKE_SOURCE_DIR}/src/examples/server.key ${CMAKE_SOURCE_DIR}/src/examples/server.pem DESTINATION ${CMAKE_BINARY_DIR})
        file(COPY ${CMAKE_SOURCE_DIR}/src/examples/server.key ${CMAKE_SOURCE_DIR}/src/examples/server.pem DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
else()
        list(REMOVE_ITEM test_source "${CMAKE_CURRENT_SOURCE_DIR}/testhttpserver.cpp")
endif()

if(UNIX_DOMAIN_SOCKET_SERVER AND UNIX_DOMAIN_SOCKET_CLIENT)
    add_definitions(-DUNIXDOMAINSOCKET_TESTING)
endif()

if(TCP_SOCKET_SERVER AND TCP_SOCKET_CLIENT)
    add_definitions(-DTCPSOCKET_TESTING)
endif()

if(COMPILE_STUBGEN)
	add_definitions(-DSTUBGEN_TESTING)
        file(GLOB test_specs *.json)
        file(COPY ${test_specs} DESTINATION ${CMAKE_BINARY_DIR})
        file(COPY ${test_specs} DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
        list(APPEND test_source "${CMAKE_BINARY_DIR}/gen/abstractstubserver.h")
        list(APPEND test_source "${CMAKE_BINARY_DIR}/gen/stubclient.h")
endif()

add_executable(unit_testsuite ${test_source})
target_link_libraries(unit_testsuite jsonrpccommon)
target_link_libraries(unit_testsuite jsonrpcserver)
target_link_libraries(unit_testsuite jsonrpcclient)

if (NOT CATCH_FOUND)
	# let's wait for catch files to be downloaded
	add_dependencies(unit_testsuite catch)
endif()

if(COMPILE_STUBGEN)
        target_link_libraries(unit_testsuite libjsonrpcstub)
        add_dependencies(unit_testsuite libjsonrpcstub)
endif()

add_test(client ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[client]")
add_test(server ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[server]")
add_test(NAME common WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[common]")

if(HTTP_CLIENT AND HTTP_SERVER)
        add_test(NAME connector_http WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[connector_http]")
endif()

if (UNIX_DOMAIN_SOCKET_CLIENT AND UNIX_DOMAIN_SOCKET_SERVER)
        add_test(NAME connector_unixdomainsocket WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[connector_unixdomainsocket]")
endif()

if (TCP_SOCKET_CLIENT AND TCP_SOCKET_SERVER)
        add_test(NAME connector_tcpsocket WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[connector_tcpsocket]")
endif()

if(COMPILE_STUBGEN)
        add_test(NAME stubgen WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[stubgenerator]")
endif()

if(HTTP_CLIENT AND HTTP_SERVER AND COMPILE_STUBGEN)
        add_test(NAME integration WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite "[integration]")
endif()

add_test(NAME all WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/unit_testsuite)

=== debian/changelog ===
libjson-rpc-cpp (0.7.0-2.2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:08:23 +0000

libjson-rpc-cpp (0.7.0-2.2build1) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:31:09 +0000

libjson-rpc-cpp (0.7.0-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062386

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 13:29:30 +0000

libjson-rpc-cpp (0.7.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/: Apply wrap-and-sort -abst.
  * debian/control: Bump Standards-Version to 4.6.1.
  * Migrate to automatic dbgsym packages.
  * d/control: Fix Vcs-* and use Priority: optional.
  * d/changelog: Remove trailing spaces.
  * d/watch: Fix uscan upstream monitoring script.

 -- Boyuan Yang <byang@debian.org>  Sat, 08 Oct 2022 21:33:02 -0400

libjson-rpc-cpp (0.7.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with libmicrohttpd 0.9.71 (Closes: #964592)
  * debian/control: Requires libmicrohttpd-dev (>= 0.9.71)

 -- Baptiste Beauplat <lyknode@cilg.org>  Thu, 08 Oct 2020 22:45:52 +0200

libjson-rpc-cpp (0.7.0-1) unstable; urgency=medium

  * Imported Upstream version 0.7.0
  * d/patches: removed all upstream applied patches
  * d/patches: import upstream patch fixing spelling errors
  * d/control: use secure uri in vcs fields
  * d/control: bump Standards-Version: no changes required
  * d/control: added missing -dev package dependencies
  * d/*-dev.install: grab pkgconfig files

 -- Peter Spiess-Knafl <dev@spiessknafl.at>  Tue, 16 Aug 2016 10:20:11 +0200

=== debian/control ===
Source: libjson-rpc-cpp
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Peter Spiess-Knafl <dev@spiessknafl.at>
Build-Depends: dpkg-dev (>= 1.22.5),
 catch,
 cmake,
 debhelper (>= 9),
 libargtable2-dev,
 libcurl4-openssl-dev | libcurl4-nss-dev,
 libjsoncpp-dev,
 libmicrohttpd-dev (>= 0.9.71),
Standards-Version: 4.6.1
Homepage: https://github.com/cinemast/libjson-rpc-cpp
Vcs-Git: https://salsa.debian.org/debian/libjson-rpc-cpp.git
Vcs-Browser: https://salsa.debian.org/debian/libjson-rpc-cpp

Package: libjsonrpccpp-client0t64
Provides: ${t64:Provides}
Replaces: libjsonrpccpp-client0
Breaks: libjsonrpccpp-client0 (<< ${source:Version})
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libjsonrpccpp-tools,
Description: library implementing json-rpc C++ clients
 This library provides classes to easily implement JSON-RPC C++ clients.
 It comes with a built in HTTP-Client connector (based on libcurl)
 for easy data exchange. It is fully JSON-RPC 2.0 and JSON-RPC
 1.0 compatible, including:
 .
  * Type checking
  * Error response handling
  * Batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Interface for additional Client-Connectors beside HTTP
  * Positional and named parameters

Package: libjsonrpccpp-common0t64
Provides: ${t64:Provides}
Replaces: libjsonrpccpp-common0
Breaks: libjsonrpccpp-common0 (<< ${source:Version})
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libjsonrpccpp-client0t64 (= ${binary:Version}),
 libjsonrpccpp-server0t64 (= ${binary:Version}),
 libjsonrpccpp-tools (= ${binary:Version}),
Description: common functionality for server and client library
 This library provides common classes for the libjson-rpc-cpp framework like
 .
  * Exceptions
  * Error-Codes
  * Specification Parsers and Writers
  * Procedure parameter validation
 .
 This package usually only makes sense with libjsonrpccpp-client0t64 and/or
 libjsonrpccpp-server0.

Package: libjsonrpccpp-dev
Section: libdevel
Architecture: any
Depends:
 libcurl4-openssl-dev | libcurl4-nss-dev,
 libjsoncpp-dev,
 libjsonrpccpp-client0t64 (= ${binary:Version}),
 libjsonrpccpp-common0t64 (= ${binary:Version}),
 libjsonrpccpp-server0t64 (= ${binary:Version}),
 libjsonrpccpp-stub0t64 (= ${binary:Version}),
 libmicrohttpd-dev (>= 0.9.71),
 ${misc:Depends},
Description: development files for JSON-RPC C++ framework
 This package provides all required developer resources like header-files
 and statically linked libraries of the libjson-rpc-cpp framework.
 .
 Features of this framework include:
 .
  * Type checking
  * Malformed request handling
  * Handling batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Simple Interface for implementing additional Server-Connectors beside HTTP
  * Positional and named parameters

Package: libjsonrpccpp-server0t64
Provides: ${t64:Provides}
Replaces: libjsonrpccpp-server0
Breaks: libjsonrpccpp-server0 (<< ${source:Version})
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libjsonrpccpp-tools,
Description: library implementing json-rpc C++ servers
 This library provides classes to easily implement JSON-RPC C++ Server
 applications. It comes with a built in HTTP-Server connector
 (based on libmicrohttpd) for easy data exchange. It is fully JSON-RPC 2.0 and
 JSON-RPC 1.0 compatible, including:
 .
  * Type checking
  * Malformed request handling
  * Handling batch procedure calls
  * JSON-RPC Method invocation
  * JSON-RPC Notification invocation
  * Simple Interface for implementing additional Server-Connectors beside HTTP
  * Positional and named parameters

Package: libjsonrpccpp-stub0t64
Provides: ${t64:Provides}
Replaces: libjsonrpccpp-stub0
Breaks: libjsonrpccpp-stub0 (<< ${source:Version})
Architecture: any
Section: libdevel
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libjsonrpccpp-common0t64,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libjsonrpccpp-tools,
Description: library for stub generation of libjsonrpccpp based applications
 This package provides the stub generator library for the libjson-rpc-cpp
 framework. It can automatically generate full functioning C++ and JavaScript
 JSON-RPC Client classes, which are ready to use.
 .
 For JSON-RPC Server applications, this library can generate an abstract C++
 class which just has to be sub classed and implement all pure virtual methods.
 To make this possible, a interface description file (in the JSON format)
 is required, which lists all available methods with corresponding parameters
 and types.

Package: libjsonrpccpp-tools
Architecture: any
Section: libdevel
Depends:
 libjsonrpccpp-stub0t64 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libjsonrpccpp-dev,
Description: stub generator for libjsonrpccpp based applications
 This package provides the stub generator for the libjson-rpc-cpp framework.
 It can automatically generate full functioning C++ and JavaScript JSON-RPC
 Client classes, which are ready to use.
 .
 For JSON-RPC Server applications, this tool can generate an abstract C++ class
 which just has to be sub classed and implement all pure virtual methods. To
 make this possible, a simple interface description file (in the JSON format)
 is required, which lists all available methods with corresponding parameters
 and types.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DBUILD_SHARED_LIBS=YES \
		-DBUILD_STATIC_LIBS=YES \
		-DCOMPILE_EXAMPLES=YES \
		-DCOMPILE_STUBGEN=YES

override_dh_strip:
	dh_strip --dbgsym-migration='libjsonrpccpp-common0-dbg (<< 0.7.0-2~), libjsonrpccpp-server0-dbg (<< 0.7.0-2~), libjsonrpccpp-client0-dbg (<< 0.7.0-2~), libjsonrpccpp-stub0-dbg (<< 0.7.0-2~)'

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/cinemast/libjson-rpc-cpp/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
